Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limsbc.F90	(revision 3938)
@@ -10,4 +10,6 @@
    !!                 !                  + simplification of the ice-ocean stress calculation
    !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
+   !!             -   ! 2012    (D. Iovino) salt flux change
+   !!             -   ! 2012-05 (C. Rousset) add penetration solar flux
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -34,4 +36,6 @@
    USE prtctl           ! Print control
    USE cpl_oasis3, ONLY : lk_cpl
+   USE traqsr           ! clem: add penetration of solar flux into the calculation of heat budget
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -44,4 +48,5 @@
    REAL(wp)  ::   r1_rdtice            ! = 1. / rdt_ice 
    REAL(wp)  ::   epsi16 = 1.e-16_wp   ! constant values
+   REAL(wp)  ::   epsi20 = 1.e-20_wp   ! constant values
    REAL(wp)  ::   rzero  = 0._wp    
    REAL(wp)  ::   rone   = 1._wp
@@ -100,5 +105,6 @@
       INTEGER  ::   ifvt, i1mfr, idfr               ! some switches
       INTEGER  ::   iflt, ial, iadv, ifral, ifrdv
-      REAL(wp) ::   zinda, zfons, zpme              ! local scalars
+      REAL(wp) ::   zinda, zindb, zfons, zpme              ! local scalars
+      REAL(wp) ::   zfmm             ! IOVINO freezing minus melting (F-M) 
       REAL(wp), POINTER, DIMENSION(:,:) ::   zfcm1 , zfcm2    ! solar/non solar heat fluxes
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   zalb, zalbp   ! 2D/3D workspace
@@ -117,6 +123,7 @@
          DO ji = 1, jpi
             zinda   = 1.0 - MAX( rzero , SIGN( rone , - ( 1.0 - pfrld(ji,jj) ) ) )
-            ifvt    = zinda  *  MAX( rzero , SIGN( rone, -phicif  (ji,jj) ) )  !subscripts are bad here
-            i1mfr   = 1.0 - MAX( rzero , SIGN( rone ,  - ( at_i(ji,jj)       ) ) )
+            zindb   = 1.0 - MAX( rzero , SIGN( rone , - iatte(ji,jj) ) )
+            ifvt    = zinda  *  MAX( rzero , SIGN( rone, - phicif(ji,jj) ) )  !subscripts are bad here
+            i1mfr   = 1.0 - MAX( rzero , SIGN( rone ,  - at_i(ji,jj) ) )
             idfr    = 1.0 - MAX( rzero , SIGN( rone , ( 1.0 - at_i(ji,jj) ) - pfrld(ji,jj) ) )
             iflt    = zinda  * (1 - i1mfr) * (1 - ifvt )
@@ -139,9 +146,10 @@
 
             !   computation the solar flux at ocean surface
-            zfcm1(ji,jj)   = pfrld(ji,jj) * qsr(ji,jj)  + ( 1. - pfrld(ji,jj) ) * fstric(ji,jj)
+            zfcm1(ji,jj)   = pfrld(ji,jj) * qsr(ji,jj)  + &
+                 &           zindb * ( 1. - pfrld(ji,jj) ) * fstric(ji,jj) / MAX( iatte(ji,jj), epsi20 )
             ! fstric     Solar flux transmitted trough the ice
             ! qsr        Net short wave heat flux on free ocean
             ! new line
-            fscmbq(ji,jj) = ( 1.0 - pfrld(ji,jj) ) * fstric(ji,jj)
+            fscmbq(ji,jj) = zindb * ( 1.0 - pfrld(ji,jj) ) * fstric(ji,jj) / MAX( iatte(ji,jj), epsi20 )
 
             !  computation the non solar heat flux at ocean surface
@@ -178,32 +186,36 @@
 
             !!gm   this IF prevents the vertorisation of the whole loop
-            IF ( ( ji == jiindx ) .AND. ( jj == jjindx) ) THEN
-               WRITE(numout,*) ' lim_sbc : heat fluxes '
-               WRITE(numout,*) ' qsr       : ', qsr(jiindx,jjindx)
-               WRITE(numout,*) ' zfcm1     : ', zfcm1(jiindx,jjindx)
-               WRITE(numout,*) ' pfrld     : ', pfrld(jiindx,jjindx)
-               WRITE(numout,*) ' fstric    : ', fstric (jiindx,jjindx)
-               WRITE(numout,*)
-               WRITE(numout,*) ' qns       : ', qns(jiindx,jjindx)
-               WRITE(numout,*) ' zfcm2     : ', zfcm2(jiindx,jjindx)
-               WRITE(numout,*) ' zfcm1     : ', zfcm1(jiindx,jjindx)
-               WRITE(numout,*) ' ifral     : ', ifral
-               WRITE(numout,*) ' ial       : ', ial  
-               WRITE(numout,*) ' qcmif     : ', qcmif(jiindx,jjindx)
-               WRITE(numout,*) ' qldif     : ', qldif(jiindx,jjindx)
-               WRITE(numout,*) ' qcmif / dt: ', qcmif(jiindx,jjindx) * r1_rdtice
-               WRITE(numout,*) ' qldif / dt: ', qldif(jiindx,jjindx) * r1_rdtice
-               WRITE(numout,*) ' ifrdv     : ', ifrdv
-               WRITE(numout,*) ' qfvbq     : ', qfvbq(jiindx,jjindx)
-               WRITE(numout,*) ' qdtcn     : ', qdtcn(jiindx,jjindx)
-               WRITE(numout,*) ' qfvbq / dt: ', qfvbq(jiindx,jjindx) * r1_rdtice
-               WRITE(numout,*) ' qdtcn / dt: ', qdtcn(jiindx,jjindx) * r1_rdtice
-               WRITE(numout,*) ' '
-               WRITE(numout,*) ' fdtcn     : ', fdtcn(jiindx,jjindx)
-               WRITE(numout,*) ' fhmec     : ', fhmec(jiindx,jjindx)
-               WRITE(numout,*) ' fheat_rpo : ', fheat_rpo(jiindx,jjindx)
-               WRITE(numout,*) ' fhbri     : ', fhbri(jiindx,jjindx)
-               WRITE(numout,*) ' fheat_res : ', fheat_res(jiindx,jjindx)
-            ENDIF
+          !  IF ( ( ji == jiindx ) .AND. ( jj == jjindx) ) THEN
+          !     WRITE(numout,*) 'lim_sbc : heat fluxes '
+          !     WRITE(numout,*) ' at_i      : ', at_i(jiindx,jjindx)
+          !     WRITE(numout,*) ' ht_i      : ', SUM( ht_i(jiindx,jjindx,1:jpl) )
+          !     WRITE(numout,*) ' ht_s      : ', SUM( ht_s(jiindx,jjindx,1:jpl) )
+          !     WRITE(numout,*)
+          !     WRITE(numout,*) ' qsr       : ', qsr(jiindx,jjindx)
+          !     WRITE(numout,*) ' zfcm1     : ', zfcm1(jiindx,jjindx)
+          !     WRITE(numout,*) ' pfrld     : ', pfrld(jiindx,jjindx)
+          !     WRITE(numout,*) ' fstric    : ', fstric (jiindx,jjindx)
+          !     WRITE(numout,*)
+          !     WRITE(numout,*) ' qns       : ', qns(jiindx,jjindx)
+          !     WRITE(numout,*) ' zfcm2     : ', zfcm2(jiindx,jjindx)
+          !     WRITE(numout,*) ' zfcm1     : ', zfcm1(jiindx,jjindx)
+          !     WRITE(numout,*) ' ifral     : ', ifral
+          !     WRITE(numout,*) ' ial       : ', ial  
+          !     WRITE(numout,*) ' qcmif     : ', qcmif(jiindx,jjindx)
+          !     WRITE(numout,*) ' qldif     : ', qldif(jiindx,jjindx)
+          !     !WRITE(numout,*) ' qcmif / dt: ', qcmif(jiindx,jjindx) * r1_rdtice
+          !     !WRITE(numout,*) ' qldif / dt: ', qldif(jiindx,jjindx) * r1_rdtice
+          !     WRITE(numout,*) ' ifrdv     : ', ifrdv
+          !     WRITE(numout,*) ' qfvbq     : ', qfvbq(jiindx,jjindx)
+          !     WRITE(numout,*) ' qdtcn     : ', qdtcn(jiindx,jjindx)
+          !     !WRITE(numout,*) ' qfvbq / dt: ', qfvbq(jiindx,jjindx) * r1_rdtice
+          !     !WRITE(numout,*) ' qdtcn / dt: ', qdtcn(jiindx,jjindx) * r1_rdtice
+          !     WRITE(numout,*) ' '
+          !     WRITE(numout,*) ' fdtcn     : ', fdtcn(jiindx,jjindx)
+          !     WRITE(numout,*) ' fhmec     : ', fhmec(jiindx,jjindx)
+          !     WRITE(numout,*) ' fheat_rpo : ', fheat_rpo(jiindx,jjindx)
+          !     WRITE(numout,*) ' fhbri     : ', fhbri(jiindx,jjindx)
+          !     WRITE(numout,*) ' fheat_res : ', fheat_res(jiindx,jjindx)
+          !  ENDIF
             !!gm   end
          END DO
@@ -236,8 +248,8 @@
             !  computing salt exchanges at the ice/ocean interface
             !  sice should be the same as computed with the ice model
-            zfons =  ( soce_0(ji,jj) - sice_0(ji,jj) ) * rdmicif(ji,jj) * r1_rdtice 
+            !zfons =  ( soce_0(ji,jj) - sice_0(ji,jj) ) * rdmicif(ji,jj) * r1_rdtice 
             ! SOCE
-            zfons =  ( sss_m (ji,jj) - sice_0(ji,jj) ) * rdmicif(ji,jj) * r1_rdtice
-
+            !zfons =  ( sss_m (ji,jj) - sice_0(ji,jj) ) * rdmicif(ji,jj) * r1_rdtice
+            zfmm = rdmicif(ji,jj) * r1_rdtice  ! IOVINO  
             !CT useless            !  salt flux for constant salinity
             !CT useless            fsalt(ji,jj)      =  zfons / ( sss_m(ji,jj) + epsi16 ) + fsalt_res(ji,jj)
@@ -247,8 +259,8 @@
             fsbri(ji,jj)      =  zinda*fsbri(ji,jj)
             !  converting the salt fluxes from ice to a freshwater flux from ocean
-            fsalt_res(ji,jj)  =  fsalt_res(ji,jj) / ( sss_m(ji,jj) + epsi16 )
-            fseqv(ji,jj)      =  fseqv(ji,jj)     / ( sss_m(ji,jj) + epsi16 )
-            fsbri(ji,jj)      =  fsbri(ji,jj)     / ( sss_m(ji,jj) + epsi16 )
-            fsalt_rpo(ji,jj)  =  fsalt_rpo(ji,jj) / ( sss_m(ji,jj) + epsi16 )
+            ! fsalt_res(ji,jj)  =  fsalt_res(ji,jj) / ( sss_m(ji,jj) + epsi16 )
+            ! fseqv(ji,jj)      =  fseqv(ji,jj)     / ( sss_m(ji,jj) + epsi16 )
+            ! fsbri(ji,jj)      =  fsbri(ji,jj)     / ( sss_m(ji,jj) + epsi16 )
+            ! fsalt_rpo(ji,jj)  =  fsalt_rpo(ji,jj) / ( sss_m(ji,jj) + epsi16 )
 
             !  freshwater mass exchange (positive to the ice, negative for the ocean ?)
@@ -258,13 +270,15 @@
             !  POSITIVE FRESHWATER FLUX FROM THE OCEAN TO THE ICE [kg.m-2.s-1]
 
-            emp(ji,jj) = - zpme 
+            emp(ji,jj) =  - zpme + zfmm ! volume flux IOVINO  
+            ! emp(ji,jj) = - zpme 
          END DO
       END DO
 
       IF( num_sal == 2 ) THEN      ! variable ice salinity: brine drainage included in the salt flux
-         emps(:,:) = fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) + emp(:,:)
+         emps(:,:) =   fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ! + emp(:,:) ! IOVINO
       ELSE                         ! constant ice salinity:
-         emps(:,:) =              fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) + emp(:,:)
+         emps(:,:) =   fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ! + emp(:,:)              ! IOVINO
       ENDIF
+
 
       !-----------------------------------------------!
@@ -402,4 +416,7 @@
          END WHERE
       ENDIF
+      ! clem modif
+      iatte(:,:) = 1._wp
+      oatte(:,:) = 1._wp
       !
    END SUBROUTINE lim_sbc_init
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 3938)
@@ -11,4 +11,5 @@
    !!            3.3  ! 2010-11 (G. Madec) corrected snow melting heat (due to factor betas)
    !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
+   !!             -   ! 2012-05 (C. Rousset) add penetration solar flux
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -39,4 +40,5 @@
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -91,8 +93,20 @@
       REAL(wp) ::   zfntlat, zpareff, zareamin, zcoef   !    -         -
       REAL(wp), POINTER, DIMENSION(:,:) ::   zqlbsbq   ! link with lead energy budget qldif
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
       !!-------------------------------------------------------------------
 
       CALL wrk_alloc( jpi, jpj, zqlbsbq )
    
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
       !------------------------------------------------------------------------------!
       ! 1) Initialization of diagnostic variables                                    !
@@ -108,5 +122,5 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_i(ji,jj,jl) , epsi06 ) ) * nlay_i
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_i(ji,jj,jl) , epsi06 ) ) * REAL( nlay_i )
                   !0 if no ice and 1 if yes
                   zindb = 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - ht_i(ji,jj,jl) ) ) 
@@ -120,5 +134,5 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi06 ) ) * nlay_s
+                  e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi06 ) ) * REAL( nlay_s )
                   !0 if no ice and 1 if yes
                   zindb = 1.0 - MAX ( 0.0 , SIGN ( 1.0 , - ht_s(ji,jj,jl) ) ) 
@@ -133,17 +147,17 @@
       ! 1.3) Set some dummies to 0
       !-----------------------------
-      rdvosif(:,:) = 0.e0   ! variation of ice volume at surface
-      rdvobif(:,:) = 0.e0   ! variation of ice volume at bottom
-      fdvolif(:,:) = 0.e0   ! total variation of ice volume
-      rdvonif(:,:) = 0.e0   ! lateral variation of ice volume
-      fstric (:,:) = 0.e0   ! part of solar radiation transmitted through the ice
-      ffltbif(:,:) = 0.e0   ! linked with fstric
-      qfvbq  (:,:) = 0.e0   ! linked with fstric
-      rdmsnif(:,:) = 0.e0   ! variation of snow mass per unit area
-      rdmicif(:,:) = 0.e0   ! variation of ice mass per unit area
-      hicifp (:,:) = 0.e0   ! daily thermodynamic ice production. 
-      fsbri  (:,:) = 0.e0   ! brine flux contribution to salt flux to the ocean
-      fhbri  (:,:) = 0.e0   ! brine flux contribution to heat flux to the ocean
-      fseqv  (:,:) = 0.e0   ! equivalent salt flux to the ocean due to ice/growth decay
+      !clem rdvosif(:,:) = 0.e0   ! variation of ice volume at surface
+      !clem rdvobif(:,:) = 0.e0   ! variation of ice volume at bottom
+      !clem fdvolif(:,:) = 0.e0   ! total variation of ice volume
+      !clem rdvonif(:,:) = 0.e0   ! lateral variation of ice volume
+      !clem fstric (:,:) = 0.e0   ! part of solar radiation transmitted through the ice
+      !clem ffltbif(:,:) = 0.e0   ! linked with fstric
+      !clem qfvbq  (:,:) = 0.e0   ! linked with fstric
+      !clem rdmsnif(:,:) = 0.e0   ! variation of snow mass per unit area
+      !clem rdmicif(:,:) = 0.e0   ! variation of ice mass per unit area
+      !clem hicifp (:,:) = 0.e0   ! daily thermodynamic ice production. 
+      !clem fsbri  (:,:) = 0.e0   ! brine flux contribution to salt flux to the ocean
+      !clem fhbri  (:,:) = 0.e0   ! brine flux contribution to heat flux to the ocean
+      !clem fseqv  (:,:) = 0.e0   ! equivalent salt flux to the ocean due to ice/growth decay
 
       !-----------------------------------
@@ -164,9 +178,9 @@
 !CDIR NOVERRCHK
          DO ji = 1, jpi
-            zthsnice       = SUM( ht_s(ji,jj,1:jpl) ) + SUM( ht_i(ji,jj,1:jpl) )
-            zindb          = tms(ji,jj) * ( 1.0 - MAX( zzero , SIGN( zone , - zthsnice ) ) ) 
+            !clem zthsnice       = SUM( ht_s(ji,jj,1:jpl) ) + SUM( ht_i(ji,jj,1:jpl) )
+            !clem zindb          = tms(ji,jj) * ( 1.0 - MAX( zzero , SIGN( zone , - zthsnice + epsi20 ) ) ) 
             phicif(ji,jj)  = vt_i(ji,jj)
             pfrld(ji,jj)   = 1.0 - at_i(ji,jj)
-            zinda          = 1.0 - MAX( zzero , SIGN( zone , - ( 1.0 - pfrld(ji,jj) ) ) )
+            zinda          = tms(ji,jj) * (1.0 - MAX( zzero , SIGN( zone , - at_i(ji,jj) ) ) )
             !
             !           !  solar irradiance transmission at the mixed layer bottom and used in the lead heat budget
@@ -179,16 +193,16 @@
 
             ! here the drag will depend on ice thickness and type (0.006)
-            fdtcn(ji,jj)  = zindb * rau0 * rcp * 0.006  * zfric_u * ( (sst_m(ji,jj) + rt0) - t_bo(ji,jj) ) 
+            fdtcn(ji,jj)  = zinda * rau0 * rcp * 0.006  * zfric_u * ( (sst_m(ji,jj) + rt0) - t_bo(ji,jj) ) 
             ! also category dependent
             !           !-- Energy from the turbulent oceanic heat flux heat flux coming in the lead 
-            qdtcn(ji,jj)  = zindb * fdtcn(ji,jj) * (1.0 - at_i(ji,jj)) * rdt_ice
+            qdtcn(ji,jj)  = zinda * fdtcn(ji,jj) * (1.0 - at_i(ji,jj)) * rdt_ice
             !                       
             !           !-- Lead heat budget, qldif (part 1, next one is in limthd_dh) 
             !           !   caution: exponent betas used as more snow can fallinto leads
             qldif(ji,jj) =  tms(ji,jj) * rdt_ice  * (                             &
-               &   pfrld(ji,jj)        * (  qsr(ji,jj)                            &   ! solar heat
+               &   pfrld(ji,jj)        * (  qsr(ji,jj) * oatte(ji,jj)             &   ! solar heat + clem modif
                &                            + qns(ji,jj)                          &   ! non solar heat
                &                            + fdtcn(ji,jj)                        &   ! turbulent ice-ocean heat
-               &                            + fsbbq(ji,jj) * ( 1.0 - zindb )  )   &   ! residual heat from previous step
+               &                            + fsbbq(ji,jj) * ( 1.0 - zinda )  )   &   ! residual heat from previous step
                & - pfrld(ji,jj)**betas * sprecip(ji,jj) * lfus                    )   ! latent heat of sprecip melting
             !
@@ -205,8 +219,8 @@
             !
             ! Energy needed to bring ocean surface layer until its freezing (qcmif, limflx)
-            qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( t_bo(ji,jj) - (sst_m(ji,jj) + rt0) ) * ( 1. - zinda )
+            qcmif  (ji,jj) =  rau0 * rcp * fse3t(ji,jj,1) * ( t_bo(ji,jj) - (sst_m(ji,jj) + rt0) ) !!clem * ( 1. - zinda )
             !
             ! oceanic heat flux (limthd_dh)
-            fbif   (ji,jj) = zindb * (  fsbbq(ji,jj) / MAX( at_i(ji,jj) , epsi20 ) + fdtcn(ji,jj) )
+            fbif   (ji,jj) = zinda * (  fsbbq(ji,jj) / MAX( at_i(ji,jj) , epsi20 ) + fdtcn(ji,jj) )
             !
          END DO
@@ -294,5 +308,6 @@
             CALL tab_2d_1d( nbpb, fstbif_1d  (1:nbpb), fstric     , jpi, jpj, npb(1:nbpb) )
             CALL tab_2d_1d( nbpb, qfvbq_1d   (1:nbpb), qfvbq      , jpi, jpj, npb(1:nbpb) )
-
+            CALL tab_2d_1d( nbpb, iatte_1d   (1:nbpb), iatte(:,:) , jpi, jpj, npb(1:nbpb) ) ! clem modif
+            CALL tab_2d_1d( nbpb, oatte_1d   (1:nbpb), oatte(:,:) , jpi, jpj, npb(1:nbpb) ) ! clem modif
             !--------------------------------
             ! 4.3) Thermodynamic processes
@@ -305,7 +320,7 @@
             CALL lim_thd_dif( 1, nbpb, jl )   ! Ice/Snow Temperature profile    !
             !                                 !---------------------------------!
-
+!
             CALL lim_thd_enmelt( 1, nbpb )    ! computes sea ice energy of melting compulsory for limthd_dh
-
+!
             IF( con_i )   CALL lim_thd_glohec ( qt_i_fin, qt_s_fin, q_i_layer_fin, 1, nbpb, jl ) 
             IF( con_i )   CALL lim_thd_con_dif( 1 , nbpb , jl )
@@ -314,13 +329,10 @@
             CALL lim_thd_dh( 1, nbpb, jl )    ! Ice/Snow thickness              ! 
             !                                 !---------------------------------!
-
             !                                 !---------------------------------!
             CALL lim_thd_ent( 1, nbpb, jl )   ! Ice/Snow enthalpy remapping     !
             !                                 !---------------------------------!
-
             !                                 !---------------------------------!
             CALL lim_thd_sal( 1, nbpb )       ! Ice salinity computation        !
             !                                 !---------------------------------!
-
             !           CALL lim_thd_enmelt(1,nbpb)   ! computes sea ice energy of melting
             IF( con_i )   CALL lim_thd_glohec( qt_i_fin, qt_s_fin, q_i_layer_fin, 1, nbpb, jl ) 
@@ -418,6 +430,6 @@
       ! 5.4) Diagnostic thermodynamic growth rates
       !--------------------------------------------
-      d_v_i_thd(:,:,:) = v_i      (:,:,:) - old_v_i(:,:,:)    ! ice volumes 
-      dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) / rdt_ice * 86400.0
+!clem@useless      d_v_i_thd(:,:,:) = v_i      (:,:,:) - old_v_i(:,:,:)    ! ice volumes 
+!clem@mv-to-itd    dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) / rdt_ice * 86400.0
 
       IF( con_i )   fbif(:,:) = fbif(:,:) + zqlbsbq(:,:)
@@ -455,4 +467,23 @@
       ENDIF
       !
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limthd) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4 ) WRITE(numout,*) 'violation saline [psu*m3/day] (limthd) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limthd) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MAXVAL( SUM(a_i(:,:,:),dim=3) ) >  amax+epsi10 ) WRITE(numout,*) 'violation a_i>amax    (limthd) = ',MAXVAL(SUM(a_i,dim=3))
+         ENDIF
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+      !
       CALL wrk_dealloc( jpi, jpj, zqlbsbq )
       !
@@ -479,10 +510,10 @@
       DO jk = 1, nlay_i                ! total q over all layers, ice [J.m-2]
          DO ji = kideb, kiut
-            etilayer(ji,jk) = q_i_b(ji,jk) * ht_i_b(ji) / nlay_i
+            etilayer(ji,jk) = q_i_b(ji,jk) * ht_i_b(ji) / REAL( nlay_i )
             eti     (ji,jl) = eti(ji,jl) + etilayer(ji,jk) 
          END DO
       END DO
       DO ji = kideb, kiut              ! total q over all layers, snow [J.m-2]
-         ets(ji,jl) = ets(ji,jl) + q_s_b(ji,1) * ht_s_b(ji) / nlay_s
+         ets(ji,jl) = ets(ji,jl) + q_s_b(ji,1) * ht_s_b(ji) / REAL( nlay_s )
       END DO
       !
@@ -799,5 +830,5 @@
       !!-------------------------------------------------------------------
       NAMELIST/namicethd/ hmelt , hiccrit, fraz_swi, maxfrazb, vfrazb, Cfrazb,   &
-         &                hicmin, hiclim, amax  ,                                &
+         &                hicmin, hiclim,                                        &
          &                sbeta  , parlat, hakspl, hibspl, exld,                 &
          &                hakdif, hnzst  , thth  , parsub, alphs, betas,         & 
@@ -825,5 +856,4 @@
          WRITE(numout,*)'      ice thick. corr. to max. energy stored in brine pocket  hicmin       = ', hicmin  
          WRITE(numout,*)'      minimum ice thickness                                   hiclim       = ', hiclim 
-         WRITE(numout,*)'      maximum lead fraction                                   amax         = ', amax 
          WRITE(numout,*)'      numerical carac. of the scheme for diffusion in ice '
          WRITE(numout,*)'      Cranck-Nicholson (=0.5), implicit (=1), explicit (=0)   sbeta        = ', sbeta
